
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
import random
from rng import *
from time import *
from math import *
from strength import *
from dexterity import *

class Bullfrog2(Gameobject):
    "Bullfrog"
    def __init__(self,xx,yy):
	Gameobject.__init__(self, xx, yy)
        self.w = 100
        self.h = 100
        self.theta = 0
        self.PI = 3.14152829
        self.hitpoints = 5
	self.strength = Strength(8)
	self.dexterity = Dexterity(8)        
	self.stimlibleft = Stateimagelibrary()	
	self.stimlibright = Stateimagelibrary()	
	self.stimlibdown = Stateimagelibrary()	
	self.stimlibup = Stateimagelibrary()	
        image = pygame.image.load('./pics/bullfrog2.1-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.1-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.1-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.1-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.4-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.4-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.4-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.4-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.3-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/bullfrog2.2-100x100.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	
	self.talkcounter = 0
	self.direction = "left"

        self.flag = 1
        
    def draw(self, screen, room):
        self.stimlibleft.draw(screen, self.x,self.y)
	     
    def update(self,room,player):
        if self.y < 17*17 and self.flag:
            self.y = self.x*self.x/30
            self.x += 1
##        if abs(self.y-200) < 20:
##            self.x = 0
##            self.flag = 0
####            if self.flag == 1:
##                self.flag = 0
##            elif self.flag == 0:
##                self.flag = 1
##        if self.y >= 20*20:
##            if self.x >= 20 or self.y == 20*20:
##                self.x = 0
##                
##            self.y = -self.x*self.x/30+200
##            self.x += 1
            #self.flag = 1
##        if self.y > 200 and self.flag:
##             self.flag = 0
##            
        self.theta -= .1
        
        if self.theta > self.PI/2:## or self.y < player.y:
            self.theta = 0
        self.y += sin(self.theta) * 1
      
        

    def collide(self, room, player):
        # FIX BUG FIXME2 collide in fight should overlap seriously with player
        #print 'gameobject x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
	if (player.x-room.relativex > self.x  and 
	player.x-room.relativex < self.x+self.w and 
	player.y-room.relativey > self.y and 
	player.y-room.relativey < self.y + self.h):
	    #print "collision with Game Object!"
	    return 1 
	else:
	    return 0 ## for game self.talker


    def fight(self,room,player):
        self.fightcounter = 1
        o = player.collidewithenemyweapon(room,self)
        if o:
            player.hitwithenemyweapon(self.getrng().rollbullfrog())
