
# Copyright (C) Johan Ceuppens 2015
# Copyright (C) Johan Ceuppens 2014
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
import random
from time import *

class CaveBat4(Gameobject):
    "CaveBat"
    def __init__(self,xx,yy):
	Gameobject.__init__(self, xx, yy)
        self.w = 48
        self.h = 48

        self.hitpoints = 3
        
	self.stimlibleft = Stateimagelibrary()	
	self.stimlibright = Stateimagelibrary()	
        image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)	
        image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)

	image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)	
        image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibleft.addpicture(image)

        image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)	
        image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/beholderbat1-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)
	
        image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)	
        image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/beholderbat2-48x48.bmp').convert()
        image.set_colorkey((255,0,0)) 
	self.stimlibright.addpicture(image)

	self.activated = 0
	self.direction = "left"

    def draw(self, screen, room):
	if (self.direction == "right"):
            self.stimlibright.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif (self.direction == "left"):
            self.stimlibleft.draw(screen, self.x+room.relativex,self.y+room.relativey)
	     
    def update(self,room,player):
	if self.activated > 0:
		if self.activated == 1:
			self.x -= 6
		elif self.activated == 2:	
			self.x += 6
		
		if abs(player.y-room.relativey - self.y) > 5:
			self.y += 13 
	
		return

	if ((player.x-room.relativex > self.x - 70 and player.x-room.relativex < self.x + self.w + 70) and
		(player.y-room.relativey > self.y - 120 and player.y-room.relativey < self.y + self.h + 120)):
		if player.x-room.relativex < self.x:
			self.activated = 1
		elif player.x-room.relativex > self.x:
			self.activated = 2
		

		

    def fight(self,room,player):
        o = player.collidewithenemyweapon(room,self)
        if o:
            player.hitwithenemyweapon(self.getrng().rollcavebat1())

