
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
from pygame.locals import *

from spellbookitem import *

class SpellBookScrollMagicMissile3(SpellBookitem):
    "Contains the spell magic missile level 1"
    def __init__(self):
        SpellBookitem.__init__(self, "./pics/scrolls-magicmissile3.bmp")
        self.image.set_colorkey((255,255,255))
	self.id = 3
	self.manapoints = 1
       	self.spellname = "Magic Missile (3)" 

    def use(self,e,game):
        print 'You used a Scroll MM 3 on %s' % e

    def setintaskbar(self,taskbar):
        taskbar.setscrollmagicmissile3(self)
