
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from fireballenemy1 import *

class FireballEnemy2(FireballEnemy1):
    ""
    def __init__(self, xx,yy,ox,oy,player):
        FireballEnemy1.__init__(self,xx,yy,ox,oy,player)

    def update(self,room,player):
	print "fireball2 enemy x=%d y=%d player x=%d y=%d" % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
	if abs(self.x-player.x+room.relativex) < player.w + 1:
		if abs(self.y-player.y+room.relativey) < player.h:
			player.hitwithenemyweapon(self.getrng().rollfireball2())
		room.removeobject(self)

	if player.x-room.relativex < self.x:
		self.x -= 15
	elif player.x-room.relativex > self.x:
		self.x += 15
	###if player.x+room.relativex < self.ox:
	###	self.x += 15
	###elif player.x+room.relativex > self.ox:
	###	self.x -= 15
	###	
	###if abs(self.x-self.ox) < 20:
	###	room.removeobject(self)
