
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
import random
from rng import *
from time import *
from math import *
from strength import *
from dexterity import *

class Fishman1(Gameobject):
    "Jumping Fishman"
    def __init__(self,xx,yy):
	Gameobject.__init__(self, xx, yy)
        self.w = 72
        self.h = 72
        self.theta = 0
        self.PI = 3.14152829
        self.hitpoints = 5
	self.strength = Strength(10)
       	self.dexterity = Dexterity(10) 
	self.stimlibleft = Stateimagelibrary()	
	self.stimlibright = Stateimagelibrary()	
	self.stimlib = Stateimagelibrary()	
        image = pygame.image.load('./pics/fishmanleft1-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft1-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft1-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft1-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft4-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft4-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft4-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft4-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft3-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/fishmanleft2-80x80.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)

	image = pygame.image.load('./pics/fishmanright0-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright0-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright0-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright0-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
        image = pygame.image.load('./pics/fishmanright1-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright1-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright1-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright1-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright3-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright3-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright3-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright3-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright3-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/fishmanright2-92x92.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)


        image = pygame.image.load('./pics/fishman1-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman1-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman1-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman1-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman4-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman4-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman4-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman4-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman3-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	image = pygame.image.load('./pics/fishman2-72x72.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)
	

	self.talkcounter = 0
	self.direction = "left"
        self.jumping = 1
        
    def draw(self, screen, room):
	if (self.direction == "left"):
            self.stimlibleft.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif (self.direction == "right"):
            self.stimlibright.draw(screen, self.x+room.relativex,self.y+room.relativey)
	elif self.direction == "down" or self.direction == "up":
            self.stimlib.draw(screen, self.x+room.relativex,self.y+room.relativey)
	     
    def update(self,room,player):

        if self.jumping:
            # FIXME
            self.direction = "up"
            if self.y < 100:
                self.jumping = 0
            else:
                self.y -= 8
                self.direction = "down"
                return
        else:
            self.y += 8
                        
        # FIX for crawling to the right on a platform
        box = room.collideboxeswithenemy(self)
	if box and self.y+self.h > box.y:
	    #if (self.direction == "right"):
            if self.x-room.relativex < player.x:
                self.direction = "right"
                self.x +=4
            elif self.x-room.relativex > player.x:
                self.direction = "left"
                self.x -= 4
	    self.y -= 8
	    
	else:
            self.x += 20
            box = room.collideboxeswithenemy(self)
            if not box:##self.direction == "left" or self.direction == "right":
                print '+++++++++++++++++++++123'
            # FIXself.jumping = 1
##	        self.direction = "left" 
##	    elif (self.direction == "left"):
##	        self.x +=4
##	        self.direction = "right"
##	    elif (self.direction == "down"):
##	        self.y -=4
##	        self.direction = "up" 
##	    elif (self.direction == "up"):
##	        self.y +=4
##	        self.direction = "down"
##
##	if player.x+28-room.relativex < self.x:
##		self.x -= 3
##		self.direction = "left"
##	if player.x-28-room.relativex > self.x:
##		self.direction = "right"
##		self.x += 3	
##	if player.y+10-room.relativey < self.y:
##		self.direction = "up"
##		self.y -= 2
##	if player.y-10-room.relativey > self.y:
##		self.direction = "down"
##		self.y += 2

        

    def collide(self, room, player):
        # FIX BUG
        #print 'gameobject x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
	if (player.x-room.relativex > self.x  and 
	player.x-room.relativex < self.x+self.w and 
	player.y-room.relativey > self.y and 
	player.y-room.relativey < self.y + self.h):
	    #print "collision with Game Object!"
	    return 1 
	else:
	    return 0 ## for game self.talker

    def collideboxes(self, room, entityorbox):
        # NOTE: that no relx rely from  map are needed
        #print 'gameobject x=%d y=%d entityorbox x=%d y=%d' % (self.x,self.y,entityorbox.x-room.relativex,entityorbox.y-room.relativey)
##	if (entityorbox.x > self.x  and 
##	entityorbox.x < self.x+self.w and
        print "collision with Fishman and box!"
	if (entityorbox.y > self.y and 
	entityorbox.y < self.y + self.h):
	    print "collision with Fishman and box!"
	    return 1 
	else:
	    return 0 ## for game self.talker


    def fight(self,room,player):
        self.fightcounter = 1
        o = player.collidewithenemyweapon(room,self)
        if o:
            player.hitwithenemyweapon(self.getrng().rollfishman())


    def collidewithenemy(self,room,entityorbox):
        if self.collideboxes(room, entityorbox):# NOTE the enemy is player above 
            return 1
        else:
            return 0
