
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
# This is a type of beholder
#

import pygame
from pygame.locals import *
from gameobject import *
from gameobjectmagicuser import *
from stateimagelibrary import *
import random
from rng import *
from time import *
from strength import *
from dexterity import *
from necromancerspelldictionaryenemy import *
from beholderspelldictionaryenemy1 import *
from gauthspelldictionaryenemy1 import *

from beholder import *

class Gauth(Beholder):
    "Gauth Beholder"
    def __init__(self,xx,yy,game):
	Gameobject.__init__(self, xx, yy)
	Beholder.__init__(self, xx,yy, self.rng, self.rng.rolld10()+50, ["Magic Missile 1", "Shocking Grasp", "Vampiric Touch"], GauthSpellDictionaryEnemy1(game, self), game)
        self.hitpoints = 10 
	self.level = self.rng.rolld10()
	self.type = -10
	self.strength = Strength(11)
	self.dexterity = Dexterity(15)
	self.agility = Agility(self.getrng().rolld6()+100)
	self.luck = Luck(self.getrng().rolld4()+100)
        
	self.talkcounter = 0
	self.direction = "left"

    def fight(self,room,player):
        self.fightcounter = 1
        o = player.collidewithenemyweapon(room,self)
        if o:
            player.hitwithenemyweapon(self.getrng().rollgauthbeholder())

    def cast(self, room, player):
	if self.magic.get() <= 0:
		return -1
	
	castp = self.rng.rolld7()

	if castp == 1:
		spellchoice = self.rng.rollbetween(0, len(self.spells.keys()))
		i = 0
		for k in self.spells.keys():
			if i == spellchoice:
				### print "enemy casts!"
				self.spells[k]()
				break	
			i += 1	
			
