
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from roadsign import *
from stateimagelibrary import *
import random
from time import *

class KibiraRoadSign(RoadSign):
    ""
    def __init__(self,xx,yy):
	RoadSign.__init__(self, xx, yy)
        
    def update(self,room,player):
        1

    def collide(self, room, player):
	if (player.x-room.relativex >= self.x-self.w  and 
	player.x-room.relativex <= self.x+self.w+self.w and 
	player.y-room.relativey >= self.y and#-self.h and 
	player.y-room.relativey <= self.y + self.h):
	    return 2
	else:
	    return 0
	
    def talk(self, screen,font):
        if self.talkcounter == 0:
            return
        
        if self.talkcounter > 1:
                self.talkcounter = 0
                return 
        talkover = 0
        while talkover == 0:
            pygame.display.update()
            if self.talkcounter == 1:
                screen.blit(font.render("<- Town of Kibira", 6, (255,255,255)), (100,100))
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_z or event.key == K_x:
                        talkover = 1
                        self.talkcounter += 1
                
