
# Copyright (C) Johan Ceuppens 2014
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
from pygame.locals import *

from priestspellsitem import *

class PriestSpellsCureLightWounds(PriestSpellsitem):
    "Contains the spell cure light wounds"
    def __init__(self):
        PriestSpellsitem.__init__(self, "./pics/priestspell-curelightwounds.bmp")
        self.image.set_colorkey((0,0,0))
	self.id = 2
	self.priestpoints = 2 
       	self.priestspellname = "Cure Light Wounds" 

        
    def use(self,e,game):
        print 'You used a Cure Light Wounds on %s' % e

    def setintaskbar(self,taskbar):
        taskbar.setpriestcurelightwounds(self)
